'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = require('react');
var React__default = _interopDefault(React);
var authorizerJs = require('@authorizerdev/authorizer-js');

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
  try {
    var info = gen[key](arg);
    var value = info.value;
  } catch (error) {
    reject(error);
    return;
  }
  if (info.done) {
    resolve(value);
  } else {
    Promise.resolve(value).then(_next, _throw);
  }
}
function _asyncToGenerator(fn) {
  return function () {
    var self = this,
      args = arguments;
    return new Promise(function (resolve, reject) {
      var gen = fn.apply(self, args);
      function _next(value) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
      }
      function _throw(err) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
      }
      _next(undefined);
    });
  };
}
function _extends() {
  _extends = Object.assign ? Object.assign.bind() : function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}

function createCommonjsModule(fn, module) {
	return module = { exports: {} }, fn(module, module.exports), module.exports;
}

var runtime_1 = createCommonjsModule(function (module) {
/**
 * Copyright (c) 2014-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

var runtime = (function (exports) {

  var Op = Object.prototype;
  var hasOwn = Op.hasOwnProperty;
  var undefined$1; // More compressible than void 0.
  var $Symbol = typeof Symbol === "function" ? Symbol : {};
  var iteratorSymbol = $Symbol.iterator || "@@iterator";
  var asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator";
  var toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";

  function define(obj, key, value) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
    return obj[key];
  }
  try {
    // IE 8 has a broken Object.defineProperty that only works on DOM objects.
    define({}, "");
  } catch (err) {
    define = function(obj, key, value) {
      return obj[key] = value;
    };
  }

  function wrap(innerFn, outerFn, self, tryLocsList) {
    // If outerFn provided and outerFn.prototype is a Generator, then outerFn.prototype instanceof Generator.
    var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator;
    var generator = Object.create(protoGenerator.prototype);
    var context = new Context(tryLocsList || []);

    // The ._invoke method unifies the implementations of the .next,
    // .throw, and .return methods.
    generator._invoke = makeInvokeMethod(innerFn, self, context);

    return generator;
  }
  exports.wrap = wrap;

  // Try/catch helper to minimize deoptimizations. Returns a completion
  // record like context.tryEntries[i].completion. This interface could
  // have been (and was previously) designed to take a closure to be
  // invoked without arguments, but in all the cases we care about we
  // already have an existing method we want to call, so there's no need
  // to create a new function object. We can even get away with assuming
  // the method takes exactly one argument, since that happens to be true
  // in every case, so we don't have to touch the arguments object. The
  // only additional allocation required is the completion record, which
  // has a stable shape and so hopefully should be cheap to allocate.
  function tryCatch(fn, obj, arg) {
    try {
      return { type: "normal", arg: fn.call(obj, arg) };
    } catch (err) {
      return { type: "throw", arg: err };
    }
  }

  var GenStateSuspendedStart = "suspendedStart";
  var GenStateSuspendedYield = "suspendedYield";
  var GenStateExecuting = "executing";
  var GenStateCompleted = "completed";

  // Returning this object from the innerFn has the same effect as
  // breaking out of the dispatch switch statement.
  var ContinueSentinel = {};

  // Dummy constructor functions that we use as the .constructor and
  // .constructor.prototype properties for functions that return Generator
  // objects. For full spec compliance, you may wish to configure your
  // minifier not to mangle the names of these two functions.
  function Generator() {}
  function GeneratorFunction() {}
  function GeneratorFunctionPrototype() {}

  // This is a polyfill for %IteratorPrototype% for environments that
  // don't natively support it.
  var IteratorPrototype = {};
  define(IteratorPrototype, iteratorSymbol, function () {
    return this;
  });

  var getProto = Object.getPrototypeOf;
  var NativeIteratorPrototype = getProto && getProto(getProto(values([])));
  if (NativeIteratorPrototype &&
      NativeIteratorPrototype !== Op &&
      hasOwn.call(NativeIteratorPrototype, iteratorSymbol)) {
    // This environment has a native %IteratorPrototype%; use it instead
    // of the polyfill.
    IteratorPrototype = NativeIteratorPrototype;
  }

  var Gp = GeneratorFunctionPrototype.prototype =
    Generator.prototype = Object.create(IteratorPrototype);
  GeneratorFunction.prototype = GeneratorFunctionPrototype;
  define(Gp, "constructor", GeneratorFunctionPrototype);
  define(GeneratorFunctionPrototype, "constructor", GeneratorFunction);
  GeneratorFunction.displayName = define(
    GeneratorFunctionPrototype,
    toStringTagSymbol,
    "GeneratorFunction"
  );

  // Helper for defining the .next, .throw, and .return methods of the
  // Iterator interface in terms of a single ._invoke method.
  function defineIteratorMethods(prototype) {
    ["next", "throw", "return"].forEach(function(method) {
      define(prototype, method, function(arg) {
        return this._invoke(method, arg);
      });
    });
  }

  exports.isGeneratorFunction = function(genFun) {
    var ctor = typeof genFun === "function" && genFun.constructor;
    return ctor
      ? ctor === GeneratorFunction ||
        // For the native GeneratorFunction constructor, the best we can
        // do is to check its .name property.
        (ctor.displayName || ctor.name) === "GeneratorFunction"
      : false;
  };

  exports.mark = function(genFun) {
    if (Object.setPrototypeOf) {
      Object.setPrototypeOf(genFun, GeneratorFunctionPrototype);
    } else {
      genFun.__proto__ = GeneratorFunctionPrototype;
      define(genFun, toStringTagSymbol, "GeneratorFunction");
    }
    genFun.prototype = Object.create(Gp);
    return genFun;
  };

  // Within the body of any async function, `await x` is transformed to
  // `yield regeneratorRuntime.awrap(x)`, so that the runtime can test
  // `hasOwn.call(value, "__await")` to determine if the yielded value is
  // meant to be awaited.
  exports.awrap = function(arg) {
    return { __await: arg };
  };

  function AsyncIterator(generator, PromiseImpl) {
    function invoke(method, arg, resolve, reject) {
      var record = tryCatch(generator[method], generator, arg);
      if (record.type === "throw") {
        reject(record.arg);
      } else {
        var result = record.arg;
        var value = result.value;
        if (value &&
            typeof value === "object" &&
            hasOwn.call(value, "__await")) {
          return PromiseImpl.resolve(value.__await).then(function(value) {
            invoke("next", value, resolve, reject);
          }, function(err) {
            invoke("throw", err, resolve, reject);
          });
        }

        return PromiseImpl.resolve(value).then(function(unwrapped) {
          // When a yielded Promise is resolved, its final value becomes
          // the .value of the Promise<{value,done}> result for the
          // current iteration.
          result.value = unwrapped;
          resolve(result);
        }, function(error) {
          // If a rejected Promise was yielded, throw the rejection back
          // into the async generator function so it can be handled there.
          return invoke("throw", error, resolve, reject);
        });
      }
    }

    var previousPromise;

    function enqueue(method, arg) {
      function callInvokeWithMethodAndArg() {
        return new PromiseImpl(function(resolve, reject) {
          invoke(method, arg, resolve, reject);
        });
      }

      return previousPromise =
        // If enqueue has been called before, then we want to wait until
        // all previous Promises have been resolved before calling invoke,
        // so that results are always delivered in the correct order. If
        // enqueue has not been called before, then it is important to
        // call invoke immediately, without waiting on a callback to fire,
        // so that the async generator function has the opportunity to do
        // any necessary setup in a predictable way. This predictability
        // is why the Promise constructor synchronously invokes its
        // executor callback, and why async functions synchronously
        // execute code before the first await. Since we implement simple
        // async functions in terms of async generators, it is especially
        // important to get this right, even though it requires care.
        previousPromise ? previousPromise.then(
          callInvokeWithMethodAndArg,
          // Avoid propagating failures to Promises returned by later
          // invocations of the iterator.
          callInvokeWithMethodAndArg
        ) : callInvokeWithMethodAndArg();
    }

    // Define the unified helper method that is used to implement .next,
    // .throw, and .return (see defineIteratorMethods).
    this._invoke = enqueue;
  }

  defineIteratorMethods(AsyncIterator.prototype);
  define(AsyncIterator.prototype, asyncIteratorSymbol, function () {
    return this;
  });
  exports.AsyncIterator = AsyncIterator;

  // Note that simple async functions are implemented on top of
  // AsyncIterator objects; they just return a Promise for the value of
  // the final result produced by the iterator.
  exports.async = function(innerFn, outerFn, self, tryLocsList, PromiseImpl) {
    if (PromiseImpl === void 0) PromiseImpl = Promise;

    var iter = new AsyncIterator(
      wrap(innerFn, outerFn, self, tryLocsList),
      PromiseImpl
    );

    return exports.isGeneratorFunction(outerFn)
      ? iter // If outerFn is a generator, return the full iterator.
      : iter.next().then(function(result) {
          return result.done ? result.value : iter.next();
        });
  };

  function makeInvokeMethod(innerFn, self, context) {
    var state = GenStateSuspendedStart;

    return function invoke(method, arg) {
      if (state === GenStateExecuting) {
        throw new Error("Generator is already running");
      }

      if (state === GenStateCompleted) {
        if (method === "throw") {
          throw arg;
        }

        // Be forgiving, per 25.3.3.3.3 of the spec:
        // https://people.mozilla.org/~jorendorff/es6-draft.html#sec-generatorresume
        return doneResult();
      }

      context.method = method;
      context.arg = arg;

      while (true) {
        var delegate = context.delegate;
        if (delegate) {
          var delegateResult = maybeInvokeDelegate(delegate, context);
          if (delegateResult) {
            if (delegateResult === ContinueSentinel) continue;
            return delegateResult;
          }
        }

        if (context.method === "next") {
          // Setting context._sent for legacy support of Babel's
          // function.sent implementation.
          context.sent = context._sent = context.arg;

        } else if (context.method === "throw") {
          if (state === GenStateSuspendedStart) {
            state = GenStateCompleted;
            throw context.arg;
          }

          context.dispatchException(context.arg);

        } else if (context.method === "return") {
          context.abrupt("return", context.arg);
        }

        state = GenStateExecuting;

        var record = tryCatch(innerFn, self, context);
        if (record.type === "normal") {
          // If an exception is thrown from innerFn, we leave state ===
          // GenStateExecuting and loop back for another invocation.
          state = context.done
            ? GenStateCompleted
            : GenStateSuspendedYield;

          if (record.arg === ContinueSentinel) {
            continue;
          }

          return {
            value: record.arg,
            done: context.done
          };

        } else if (record.type === "throw") {
          state = GenStateCompleted;
          // Dispatch the exception by looping back around to the
          // context.dispatchException(context.arg) call above.
          context.method = "throw";
          context.arg = record.arg;
        }
      }
    };
  }

  // Call delegate.iterator[context.method](context.arg) and handle the
  // result, either by returning a { value, done } result from the
  // delegate iterator, or by modifying context.method and context.arg,
  // setting context.delegate to null, and returning the ContinueSentinel.
  function maybeInvokeDelegate(delegate, context) {
    var method = delegate.iterator[context.method];
    if (method === undefined$1) {
      // A .throw or .return when the delegate iterator has no .throw
      // method always terminates the yield* loop.
      context.delegate = null;

      if (context.method === "throw") {
        // Note: ["return"] must be used for ES3 parsing compatibility.
        if (delegate.iterator["return"]) {
          // If the delegate iterator has a return method, give it a
          // chance to clean up.
          context.method = "return";
          context.arg = undefined$1;
          maybeInvokeDelegate(delegate, context);

          if (context.method === "throw") {
            // If maybeInvokeDelegate(context) changed context.method from
            // "return" to "throw", let that override the TypeError below.
            return ContinueSentinel;
          }
        }

        context.method = "throw";
        context.arg = new TypeError(
          "The iterator does not provide a 'throw' method");
      }

      return ContinueSentinel;
    }

    var record = tryCatch(method, delegate.iterator, context.arg);

    if (record.type === "throw") {
      context.method = "throw";
      context.arg = record.arg;
      context.delegate = null;
      return ContinueSentinel;
    }

    var info = record.arg;

    if (! info) {
      context.method = "throw";
      context.arg = new TypeError("iterator result is not an object");
      context.delegate = null;
      return ContinueSentinel;
    }

    if (info.done) {
      // Assign the result of the finished delegate to the temporary
      // variable specified by delegate.resultName (see delegateYield).
      context[delegate.resultName] = info.value;

      // Resume execution at the desired location (see delegateYield).
      context.next = delegate.nextLoc;

      // If context.method was "throw" but the delegate handled the
      // exception, let the outer generator proceed normally. If
      // context.method was "next", forget context.arg since it has been
      // "consumed" by the delegate iterator. If context.method was
      // "return", allow the original .return call to continue in the
      // outer generator.
      if (context.method !== "return") {
        context.method = "next";
        context.arg = undefined$1;
      }

    } else {
      // Re-yield the result returned by the delegate method.
      return info;
    }

    // The delegate iterator is finished, so forget it and continue with
    // the outer generator.
    context.delegate = null;
    return ContinueSentinel;
  }

  // Define Generator.prototype.{next,throw,return} in terms of the
  // unified ._invoke helper method.
  defineIteratorMethods(Gp);

  define(Gp, toStringTagSymbol, "Generator");

  // A Generator should always return itself as the iterator object when the
  // @@iterator function is called on it. Some browsers' implementations of the
  // iterator prototype chain incorrectly implement this, causing the Generator
  // object to not be returned from this call. This ensures that doesn't happen.
  // See https://github.com/facebook/regenerator/issues/274 for more details.
  define(Gp, iteratorSymbol, function() {
    return this;
  });

  define(Gp, "toString", function() {
    return "[object Generator]";
  });

  function pushTryEntry(locs) {
    var entry = { tryLoc: locs[0] };

    if (1 in locs) {
      entry.catchLoc = locs[1];
    }

    if (2 in locs) {
      entry.finallyLoc = locs[2];
      entry.afterLoc = locs[3];
    }

    this.tryEntries.push(entry);
  }

  function resetTryEntry(entry) {
    var record = entry.completion || {};
    record.type = "normal";
    delete record.arg;
    entry.completion = record;
  }

  function Context(tryLocsList) {
    // The root entry object (effectively a try statement without a catch
    // or a finally block) gives us a place to store values thrown from
    // locations where there is no enclosing try statement.
    this.tryEntries = [{ tryLoc: "root" }];
    tryLocsList.forEach(pushTryEntry, this);
    this.reset(true);
  }

  exports.keys = function(object) {
    var keys = [];
    for (var key in object) {
      keys.push(key);
    }
    keys.reverse();

    // Rather than returning an object with a next method, we keep
    // things simple and return the next function itself.
    return function next() {
      while (keys.length) {
        var key = keys.pop();
        if (key in object) {
          next.value = key;
          next.done = false;
          return next;
        }
      }

      // To avoid creating an additional object, we just hang the .value
      // and .done properties off the next function object itself. This
      // also ensures that the minifier will not anonymize the function.
      next.done = true;
      return next;
    };
  };

  function values(iterable) {
    if (iterable) {
      var iteratorMethod = iterable[iteratorSymbol];
      if (iteratorMethod) {
        return iteratorMethod.call(iterable);
      }

      if (typeof iterable.next === "function") {
        return iterable;
      }

      if (!isNaN(iterable.length)) {
        var i = -1, next = function next() {
          while (++i < iterable.length) {
            if (hasOwn.call(iterable, i)) {
              next.value = iterable[i];
              next.done = false;
              return next;
            }
          }

          next.value = undefined$1;
          next.done = true;

          return next;
        };

        return next.next = next;
      }
    }

    // Return an iterator with no values.
    return { next: doneResult };
  }
  exports.values = values;

  function doneResult() {
    return { value: undefined$1, done: true };
  }

  Context.prototype = {
    constructor: Context,

    reset: function(skipTempReset) {
      this.prev = 0;
      this.next = 0;
      // Resetting context._sent for legacy support of Babel's
      // function.sent implementation.
      this.sent = this._sent = undefined$1;
      this.done = false;
      this.delegate = null;

      this.method = "next";
      this.arg = undefined$1;

      this.tryEntries.forEach(resetTryEntry);

      if (!skipTempReset) {
        for (var name in this) {
          // Not sure about the optimal order of these conditions:
          if (name.charAt(0) === "t" &&
              hasOwn.call(this, name) &&
              !isNaN(+name.slice(1))) {
            this[name] = undefined$1;
          }
        }
      }
    },

    stop: function() {
      this.done = true;

      var rootEntry = this.tryEntries[0];
      var rootRecord = rootEntry.completion;
      if (rootRecord.type === "throw") {
        throw rootRecord.arg;
      }

      return this.rval;
    },

    dispatchException: function(exception) {
      if (this.done) {
        throw exception;
      }

      var context = this;
      function handle(loc, caught) {
        record.type = "throw";
        record.arg = exception;
        context.next = loc;

        if (caught) {
          // If the dispatched exception was caught by a catch block,
          // then let that catch block handle the exception normally.
          context.method = "next";
          context.arg = undefined$1;
        }

        return !! caught;
      }

      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        var record = entry.completion;

        if (entry.tryLoc === "root") {
          // Exception thrown outside of any try block that could handle
          // it, so set the completion value of the entire function to
          // throw the exception.
          return handle("end");
        }

        if (entry.tryLoc <= this.prev) {
          var hasCatch = hasOwn.call(entry, "catchLoc");
          var hasFinally = hasOwn.call(entry, "finallyLoc");

          if (hasCatch && hasFinally) {
            if (this.prev < entry.catchLoc) {
              return handle(entry.catchLoc, true);
            } else if (this.prev < entry.finallyLoc) {
              return handle(entry.finallyLoc);
            }

          } else if (hasCatch) {
            if (this.prev < entry.catchLoc) {
              return handle(entry.catchLoc, true);
            }

          } else if (hasFinally) {
            if (this.prev < entry.finallyLoc) {
              return handle(entry.finallyLoc);
            }

          } else {
            throw new Error("try statement without catch or finally");
          }
        }
      }
    },

    abrupt: function(type, arg) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.tryLoc <= this.prev &&
            hasOwn.call(entry, "finallyLoc") &&
            this.prev < entry.finallyLoc) {
          var finallyEntry = entry;
          break;
        }
      }

      if (finallyEntry &&
          (type === "break" ||
           type === "continue") &&
          finallyEntry.tryLoc <= arg &&
          arg <= finallyEntry.finallyLoc) {
        // Ignore the finally entry if control is not jumping to a
        // location outside the try/catch block.
        finallyEntry = null;
      }

      var record = finallyEntry ? finallyEntry.completion : {};
      record.type = type;
      record.arg = arg;

      if (finallyEntry) {
        this.method = "next";
        this.next = finallyEntry.finallyLoc;
        return ContinueSentinel;
      }

      return this.complete(record);
    },

    complete: function(record, afterLoc) {
      if (record.type === "throw") {
        throw record.arg;
      }

      if (record.type === "break" ||
          record.type === "continue") {
        this.next = record.arg;
      } else if (record.type === "return") {
        this.rval = this.arg = record.arg;
        this.method = "return";
        this.next = "end";
      } else if (record.type === "normal" && afterLoc) {
        this.next = afterLoc;
      }

      return ContinueSentinel;
    },

    finish: function(finallyLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.finallyLoc === finallyLoc) {
          this.complete(entry.completion, entry.afterLoc);
          resetTryEntry(entry);
          return ContinueSentinel;
        }
      }
    },

    "catch": function(tryLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.tryLoc === tryLoc) {
          var record = entry.completion;
          if (record.type === "throw") {
            var thrown = record.arg;
            resetTryEntry(entry);
          }
          return thrown;
        }
      }

      // The context.catch method must only be called with a location
      // argument that corresponds to a known catch block.
      throw new Error("illegal catch attempt");
    },

    delegateYield: function(iterable, resultName, nextLoc) {
      this.delegate = {
        iterator: values(iterable),
        resultName: resultName,
        nextLoc: nextLoc
      };

      if (this.method === "next") {
        // Deliberately forget the last sent value so that we don't
        // accidentally pass it on to the delegate.
        this.arg = undefined$1;
      }

      return ContinueSentinel;
    }
  };

  // Regardless of whether this script is executing as a CommonJS module
  // or not, return the runtime object so that we can declare the variable
  // regeneratorRuntime in the outer scope, which allows this module to be
  // injected easily by `bin/regenerator --include-runtime script.js`.
  return exports;

}(
  // If this script is executing as a CommonJS module, use module.exports
  // as the regeneratorRuntime namespace. Otherwise create a new empty
  // object. Either way, the resulting object will be used to initialize
  // the regeneratorRuntime variable at the top of this file.
   module.exports 
));

try {
  regeneratorRuntime = runtime;
} catch (accidentalStrictMode) {
  // This module should not be running in strict mode, so the above
  // assignment should always work unless something is misconfigured. Just
  // in case runtime.js accidentally runs in strict mode, in modern engines
  // we can explicitly access globalThis. In older engines we can escape
  // strict mode using a global Function call. This could conceivably fail
  // if a Content Security Policy forbids using Function, but in that case
  // the proper solution is to fix the accidental strict mode problem. If
  // you've misconfigured your bundler to force strict mode and applied a
  // CSP to forbid Function, and you're not willing to fix either of those
  // problems, please detail your unique predicament in a GitHub issue.
  if (typeof globalThis === "object") {
    globalThis.regeneratorRuntime = runtime;
  } else {
    Function("r", "regeneratorRuntime = r")(runtime);
  }
}
});

var Views;
(function (Views) {
  Views[Views["Login"] = 0] = "Login";
  Views[Views["Signup"] = 1] = "Signup";
  Views[Views["ForgotPassword"] = 2] = "ForgotPassword";
})(Views || (Views = {}));
var ButtonAppearance;
(function (ButtonAppearance) {
  ButtonAppearance[ButtonAppearance["Primary"] = 0] = "Primary";
  ButtonAppearance[ButtonAppearance["Default"] = 1] = "Default";
})(ButtonAppearance || (ButtonAppearance = {}));
var MessageType;
(function (MessageType) {
  MessageType[MessageType["Error"] = 0] = "Error";
  MessageType[MessageType["Success"] = 1] = "Success";
})(MessageType || (MessageType = {}));
var AuthorizerProviderActionType;
(function (AuthorizerProviderActionType) {
  AuthorizerProviderActionType["SET_USER"] = "SET_USER";
  AuthorizerProviderActionType["SET_TOKEN"] = "SET_TOKEN";
  AuthorizerProviderActionType["SET_LOADING"] = "SET_LOADING";
  AuthorizerProviderActionType["SET_AUTH_DATA"] = "SET_AUTH_DATA";
  AuthorizerProviderActionType["SET_CONFIG"] = "SET_CONFIG";
})(AuthorizerProviderActionType || (AuthorizerProviderActionType = {}));
// TODO use based on theme primary color
var passwordStrengthIndicatorOpacity = {
  "default": 0.15,
  weak: 0.4,
  good: 0.6,
  strong: 0.8,
  veryStrong: 1
};

var hasWindow = function hasWindow() {
  return typeof window !== 'undefined';
};

var AuthorizerContext = /*#__PURE__*/React.createContext({
  config: {
    authorizerURL: '',
    redirectURL: '/',
    client_id: '',
    is_google_login_enabled: false,
    is_github_login_enabled: false,
    is_facebook_login_enabled: false,
    is_linkedin_login_enabled: false,
    is_apple_login_enabled: false,
    is_twitter_login_enabled: false,
    is_microsoft_login_enabled: false,
    is_email_verification_enabled: false,
    is_basic_authentication_enabled: false,
    is_magic_link_login_enabled: false,
    is_sign_up_enabled: false,
    is_strong_password_enabled: true
  },
  user: null,
  token: null,
  loading: true,
  setLoading: function setLoading() {},
  setToken: function setToken() {},
  setUser: function setUser() {},
  setAuthData: function setAuthData() {},
  authorizerRef: /*#__PURE__*/new authorizerJs.Authorizer({
    authorizerURL: "http://localhost:8080",
    redirectURL: /*#__PURE__*/hasWindow() ? window.location.origin : '/',
    clientID: ''
  }),
  logout: /*#__PURE__*/function () {
    var _logout = /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/runtime_1.mark(function _callee() {
      return runtime_1.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));
    function logout() {
      return _logout.apply(this, arguments);
    }
    return logout;
  }()
});
function reducer(state, action) {
  switch (action.type) {
    case AuthorizerProviderActionType.SET_USER:
      return _extends({}, state, {
        user: action.payload.user
      });
    case AuthorizerProviderActionType.SET_TOKEN:
      return _extends({}, state, {
        token: action.payload.token
      });
    case AuthorizerProviderActionType.SET_LOADING:
      return _extends({}, state, {
        loading: action.payload.loading
      });
    case AuthorizerProviderActionType.SET_CONFIG:
      return _extends({}, state, {
        config: action.payload.config
      });
    case AuthorizerProviderActionType.SET_AUTH_DATA:
      return _extends({}, action.payload);
    default:
      throw new Error();
  }
}
var initialState = {
  user: null,
  token: null,
  loading: true,
  config: {
    authorizerURL: '',
    redirectURL: '/',
    client_id: '',
    is_google_login_enabled: false,
    is_github_login_enabled: false,
    is_facebook_login_enabled: false,
    is_linkedin_login_enabled: false,
    is_apple_login_enabled: false,
    is_twitter_login_enabled: false,
    is_microsoft_login_enabled: false,
    is_email_verification_enabled: false,
    is_basic_authentication_enabled: false,
    is_magic_link_login_enabled: false,
    is_sign_up_enabled: false,
    is_strong_password_enabled: true
  }
};
var AuthorizerProvider = function AuthorizerProvider(_ref) {
  var defaultConfig = _ref.config,
    onStateChangeCallback = _ref.onStateChangeCallback,
    children = _ref.children;
  var _useReducer = React.useReducer(reducer, _extends({}, initialState, {
      config: _extends({}, initialState.config, defaultConfig)
    })),
    state = _useReducer[0],
    dispatch = _useReducer[1];
  var intervalRef = null;
  var authorizerRef = React.useRef(new authorizerJs.Authorizer({
    authorizerURL: state.config.authorizerURL,
    redirectURL: hasWindow() ? state.config.redirectURL || window.location.origin : state.config.redirectURL || '/',
    clientID: state.config.client_id
  }));
  var getToken = /*#__PURE__*/function () {
    var _ref2 = _asyncToGenerator( /*#__PURE__*/runtime_1.mark(function _callee2() {
      var metaRes, res, token;
      return runtime_1.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _context2.next = 2;
              return authorizerRef.current.getMetaData();
            case 2:
              metaRes = _context2.sent;
              _context2.prev = 3;
              _context2.next = 6;
              return authorizerRef.current.getSession();
            case 6:
              res = _context2.sent;
              if (res.access_token && res.user) {
                token = {
                  access_token: res.access_token,
                  expires_in: res.expires_in,
                  id_token: res.id_token,
                  refresh_token: res.refresh_token || ''
                };
                dispatch({
                  type: AuthorizerProviderActionType.SET_AUTH_DATA,
                  payload: _extends({}, state, {
                    token: token,
                    user: res.user,
                    config: _extends({}, state.config, metaRes),
                    loading: false
                  })
                });
                // const millisecond = getIntervalDiff(res.expires_at);
                // if (millisecond > 0) {
                //   if (intervalRef) clearInterval(intervalRef);
                //   intervalRef = setInterval(() => {
                //     getToken();
                //   }, millisecond);
                // }
                if (intervalRef) clearInterval(intervalRef);
                intervalRef = setInterval(function () {
                  getToken();
                }, res.expires_in * 1000);
              } else {
                dispatch({
                  type: AuthorizerProviderActionType.SET_AUTH_DATA,
                  payload: _extends({}, state, {
                    token: null,
                    user: null,
                    config: _extends({}, state.config, metaRes),
                    loading: false
                  })
                });
              }
              _context2.next = 13;
              break;
            case 10:
              _context2.prev = 10;
              _context2.t0 = _context2["catch"](3);
              dispatch({
                type: AuthorizerProviderActionType.SET_AUTH_DATA,
                payload: _extends({}, state, {
                  token: null,
                  user: null,
                  config: _extends({}, state.config, metaRes),
                  loading: false
                })
              });
            case 13:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, null, [[3, 10]]);
    }));
    return function getToken() {
      return _ref2.apply(this, arguments);
    };
  }();
  React.useEffect(function () {
    getToken();
    return function () {
      if (intervalRef) {
        clearInterval(intervalRef);
      }
    };
  }, []);
  React.useEffect(function () {
    if (onStateChangeCallback) {
      onStateChangeCallback(state);
    }
  }, [state]);
  var handleTokenChange = function handleTokenChange(token) {
    dispatch({
      type: AuthorizerProviderActionType.SET_TOKEN,
      payload: {
        token: token
      }
    });
    if (token != null && token.access_token) {
      if (intervalRef) clearInterval(intervalRef);
      intervalRef = setInterval(function () {
        getToken();
      }, token.expires_in * 1000);
    }
  };
  var setAuthData = function setAuthData(data) {
    var _data$token;
    dispatch({
      type: AuthorizerProviderActionType.SET_AUTH_DATA,
      payload: data
    });
    if ((_data$token = data.token) != null && _data$token.access_token) {
      if (intervalRef) clearInterval(intervalRef);
      intervalRef = setInterval(function () {
        getToken();
      }, data.token.expires_in * 1000);
    }
  };
  var setUser = function setUser(user) {
    dispatch({
      type: AuthorizerProviderActionType.SET_USER,
      payload: {
        user: user
      }
    });
  };
  var setLoading = function setLoading(loading) {
    dispatch({
      type: AuthorizerProviderActionType.SET_LOADING,
      payload: {
        loading: loading
      }
    });
  };
  var logout = /*#__PURE__*/function () {
    var _ref3 = _asyncToGenerator( /*#__PURE__*/runtime_1.mark(function _callee3() {
      var loggedOutState;
      return runtime_1.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              dispatch({
                type: AuthorizerProviderActionType.SET_LOADING,
                payload: {
                  loading: true
                }
              });
              _context3.next = 3;
              return authorizerRef.current.logout();
            case 3:
              loggedOutState = {
                user: null,
                token: null,
                loading: false,
                config: state.config
              };
              dispatch({
                type: AuthorizerProviderActionType.SET_AUTH_DATA,
                payload: loggedOutState
              });
            case 5:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3);
    }));
    return function logout() {
      return _ref3.apply(this, arguments);
    };
  }();
  return React__default.createElement(AuthorizerContext.Provider, {
    value: _extends({}, state, {
      setUser: setUser,
      setLoading: setLoading,
      setToken: handleTokenChange,
      setAuthData: setAuthData,
      authorizerRef: authorizerRef.current,
      logout: logout
    })
  }, children);
};
var useAuthorizer = function useAuthorizer() {
  return React.useContext(AuthorizerContext);
};

function styleInject(css, ref) {
  if ( ref === void 0 ) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') { return; }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css_248z = ":root {\n  --authorizer-primary-color: #3b82f6;\n  --authorizer-primary-disabled-color: #60a5fa;\n  --authorizer-gray-color: #d1d5db;\n  --authorizer-white-color: #ffffff;\n  --authorizer-danger-color: #dc2626;\n  --authorizer-success-color: #10b981;\n  --authorizer-text-color: #374151;\n  --authorizer-fonts-font-stack: -apple-system, system-ui, sans-serif;\n  --authorizer-fonts-large-text: 18px;\n  --authorizer-fonts-medium-text: 14px;\n  --authorizer-fonts-small-text: 12px;\n  --authorizer-fonts-tiny-text: 10px;\n  --authorizer-radius-card: 5px;\n  --authorizer-radius-button: 5px;\n  --authorizer-radius-input: 5px;\n}\n.default_styled-button__nC8O8 {\n  padding: 15px 10px !important;\n  display: flex;\n  justify-content: center;\n  align-items: center;\n  min-width: 375px;\n  max-height: 64px;\n  border-radius: var(--authorizer-radius-button);\n  border-color: var(--authorizer-text-color) !important;\n  border-style: solid !important;\n  cursor: pointer;\n  position: relative;\n}\n.default_styled-button__nC8O8:disabled {\n  cursor: not-allowed;\n  background-color: var(--authorizer-primary-disabled-color);\n}\n.default_styled-flex__-Ht-R {\n  display: flex;\n}\n.default_styled-footer__CcCGy {\n  display: flex;\n  flex-direction: column;\n  justify-content: center;\n  align-items: center;\n  margin-top: 15px;\n}\n.default_styled-form-group__ZR0-U {\n  width: 100%;\n  border: 0px;\n  background-color: var(--authorizer-white-color);\n  padding: 0 0 15px;\n}\n.default_form-input-label__UvinM {\n  padding: 2.5px;\n}\n.default_form-input-label__UvinM > span {\n  color: var(--authorizer-danger-color);\n}\n.default_form-input-field__G8P0W {\n  width: 100%;\n  margin-top: 5px;\n  padding: 10px;\n  display: flex;\n  flex-direction: column;\n  align-items: center;\n  border-radius: var(--authorizer-radius-input);\n  border: 1px;\n  border-style: solid;\n  border-color: var(--authorizer-text-color);\n}\n.default_input-error-content__Ogcjm {\n  border-color: var(--authorizer-danger-color) !important;\n}\n.default_input-error-content__Ogcjm:hover {\n  outline-color: var(--authorizer-danger-color);\n}\n.default_input-error-content__Ogcjm:focus {\n  outline-color: var(--authorizer-danger-color);\n}\n.default_form-input-error__qq-T7 {\n  font-size: 12px;\n  font-weight: 400;\n  color: red;\n  border-color: var(--authorizer-danger-color);\n}\n.default_styled-link__msGJf {\n  color: var(--authorizer-primary-color);\n  cursor: pointer;\n}\n.default_styled-message-wrapper__hPNs7 {\n  padding: 10px;\n  color: white;\n  border-radius: var(--authorizer-radius-card);\n  margin: 10px 0px;\n  font-size: var(--authorizer-fonts-small-text);\n}\n.default_styled-password-strength__MEGkw {\n  width: 100%;\n  height: 10px;\n  flex: 0.75;\n  border-radius: 5px;\n  margin-right: 5px;\n  background-color: var(--authorizer-primary-color);\n}\n.default_styled-password-strength-wrapper__F0N3N {\n  margin: 2% 0 0;\n}\n.default_styled-separator__6ukq- {\n  display: flex;\n  align-items: center;\n  text-align: center;\n  margin: 10px 0px;\n}\n.default_styled-separator__6ukq-::before {\n  content: '';\n  flex: 1;\n  border-bottom: 1px solid var(--authorizer-gray-color);\n}\n.default_styled-separator__6ukq-::after {\n  content: '';\n  flex: 1;\n  border-bottom: 1px solid var(--authorizer-gray-color);\n}\n.default_styled-separator__6ukq-:not(:empty)::before {\n  margin-right: 0.25em;\n}\n.default_styled-separator__6ukq-:not(:empty)::after {\n  margin-left: 0.25em;\n}\n.default_styled-wrapper__d53e1 {\n  font-family: var(--authorizer-fonts-font-stack);\n  color: var(--authorizer-text-color);\n  font-size: var(--authorizer-fonts-medium-text);\n  box-sizing: border-box;\n  width: 100%;\n}\n.default_styled-wrapper__d53e1 *,\n*:before,\n*:after {\n  box-sizing: inherit;\n}\n";
var styles = {"styled-button":"default_styled-button__nC8O8","styled-flex":"default_styled-flex__-Ht-R","styled-footer":"default_styled-footer__CcCGy","styled-form-group":"default_styled-form-group__ZR0-U","form-input-label":"default_form-input-label__UvinM","form-input-field":"default_form-input-field__G8P0W","input-error-content":"default_input-error-content__Ogcjm","form-input-error":"default_form-input-error__qq-T7","styled-link":"default_styled-link__msGJf","styled-message-wrapper":"default_styled-message-wrapper__hPNs7","styled-password-strength":"default_styled-password-strength__MEGkw","styled-password-strength-wrapper":"default_styled-password-strength-wrapper__F0N3N","styled-separator":"default_styled-separator__6ukq-","styled-wrapper":"default_styled-wrapper__d53e1"};
styleInject(css_248z);

var StyledWrapper = function StyledWrapper(_ref) {
  var children = _ref.children;
  return React__default.createElement("div", {
    className: styles['styled-wrapper']
  }, children);
};

var StyledButton = function StyledButton(_ref) {
  var _ref$style = _ref.style,
    style = _ref$style === void 0 ? {
      width: '100%'
    } : _ref$style,
    type = _ref.type,
    _ref$appearance = _ref.appearance,
    appearance = _ref$appearance === void 0 ? ButtonAppearance.Default : _ref$appearance,
    _ref$disabled = _ref.disabled,
    disabled = _ref$disabled === void 0 ? false : _ref$disabled,
    onClick = _ref.onClick,
    children = _ref.children;
  return React__default.createElement("button", {
    className: styles['styled-button'],
    type: type,
    style: {
      width: style.width,
      backgroundColor: disabled ? 'var(--authorizer-primary-disabled-color)' : appearance === ButtonAppearance.Primary ? 'var(--authorizer-primary-color)' : 'var(--authorizer-white-color)',
      color: appearance === ButtonAppearance.Default ? 'var(--authorizer-text-color)' : 'var(--authorizer-white-color)',
      border: appearance === ButtonAppearance.Primary ? '0px' : '1px'
    },
    disabled: disabled,
    onClick: onClick
  }, children);
};

var StyledLink = function StyledLink(_ref) {
  var _ref$marginBottom = _ref.marginBottom,
    marginBottom = _ref$marginBottom === void 0 ? '0px' : _ref$marginBottom,
    children = _ref.children,
    onClick = _ref.onClick;
  return React__default.createElement("span", {
    className: styles['styled-link'],
    style: {
      marginBottom: marginBottom
    },
    onClick: onClick
  }, children);
};

var StyledSeparator = function StyledSeparator(_ref) {
  var children = _ref.children;
  return React__default.createElement("div", {
    className: styles['styled-separator']
  }, children);
};

var StyledFooter = function StyledFooter(_ref) {
  var children = _ref.children;
  return React__default.createElement("div", {
    className: styles['styled-footer']
  }, children);
};

var StyledMessageWrapper = function StyledMessageWrapper(_ref) {
  var _ref$type = _ref.type,
    type = _ref$type === void 0 ? MessageType.Success : _ref$type,
    children = _ref.children;
  return React__default.createElement("div", {
    className: styles['styled-message-wrapper'],
    style: {
      backgroundColor: type === MessageType.Error ? 'var(--authorizer-danger-color)' : 'var(--authorizer-success-color)'
    }
  }, children);
};

var StyledFlex = function StyledFlex(_ref) {
  var _ref$flexDirection = _ref.flexDirection,
    flexDirection = _ref$flexDirection === void 0 ? 'row' : _ref$flexDirection,
    _ref$alignItems = _ref.alignItems,
    alignItems = _ref$alignItems === void 0 ? 'center' : _ref$alignItems,
    _ref$justifyContent = _ref.justifyContent,
    justifyContent = _ref$justifyContent === void 0 ? 'center' : _ref$justifyContent,
    _ref$wrap = _ref.wrap,
    wrap = _ref$wrap === void 0 ? 'wrap' : _ref$wrap,
    _ref$width = _ref.width,
    width = _ref$width === void 0 ? 'inherit' : _ref$width,
    children = _ref.children;
  return React__default.createElement("div", {
    className: styles['styled-flex'],
    style: {
      flexDirection: flexDirection,
      alignItems: alignItems,
      justifyContent: justifyContent,
      flexWrap: wrap,
      width: width
    }
  }, children);
};

var StyledPasswordStrength = function StyledPasswordStrength(_ref) {
  var _ref$strength = _ref.strength,
    strength = _ref$strength === void 0 ? 'default' : _ref$strength,
    children = _ref.children;
  return React__default.createElement("div", {
    className: styles['styled-password-strength'],
    style: {
      opacity: passwordStrengthIndicatorOpacity[strength]
    }
  }, children);
};

var StyledPasswordStrengthWrapper = function StyledPasswordStrengthWrapper(_ref) {
  var children = _ref.children;
  return React__default.createElement("div", {
    className: styles['styled-password-strength-wrapper']
  }, children);
};

var isValidEmail = function isValidEmail(email) {
  var re = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
  return re.test(String(email.trim()).toLowerCase());
};
var isValidOtp = function isValidOtp(otp) {
  var re = /^([A-Z0-9]{6})$/;
  return re.test(String(otp.trim()));
};
var hasSpecialChar = function hasSpecialChar(_char) {
  var re = /[`!@#$%^&*()_+\-=\[\]{};':"\\|,.<>\/?~]/;
  return re.test(_char);
};
var validatePassword = function validatePassword(value) {
  var res = {
    score: 0,
    strength: '',
    hasSixChar: false,
    hasLowerCase: false,
    hasUpperCase: false,
    hasNumericChar: false,
    hasSpecialChar: false,
    maxThirtySixChar: false
  };
  if (value.length >= 6) {
    res.score = res.score + 1;
    res.hasSixChar = true;
  }
  if (value.length > 0 && value.length <= 36) {
    res.score = res.score + 1;
    res.maxThirtySixChar = true;
  }
  Array.from(value).forEach(function (_char2) {
    if (_char2 >= 'A' && _char2 <= 'Z' && !res.hasUpperCase) {
      res.score = res.score + 1;
      res.hasUpperCase = true;
    } else if (_char2 >= 'a' && _char2 <= 'z' && !res.hasLowerCase) {
      res.score = res.score + 1;
      res.hasLowerCase = true;
    } else if (_char2 >= '0' && _char2 <= '9' && !res.hasNumericChar) {
      res.score = res.score + 1;
      res.hasNumericChar = true;
    } else if (hasSpecialChar(_char2) && !res.hasSpecialChar) {
      res.score = res.score + 1;
      res.hasSpecialChar = true;
    }
  });
  if (res.score <= 2) {
    res.strength = 'Weak';
  } else if (res.score <= 4) {
    res.strength = 'Good';
  } else if (res.score <= 5) {
    res.strength = 'Strong';
  } else {
    res.strength = 'Very Strong';
  }
  var isValid = Object.values(res).every(function (i) {
    return Boolean(i);
  });
  return _extends({}, res, {
    isValid: isValid
  });
};

var formatErrorMessage = function formatErrorMessage(message) {
  return message.replace("[GraphQL] ", '');
};
var capitalizeFirstLetter = function capitalizeFirstLetter(data) {
  return data.charAt(0).toUpperCase() + data.slice(1);
};

var IconClose = function IconClose() {
  return React__default.createElement("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    viewBox: "0 0 1000 1000",
    width: "10px",
    height: "10px"
  }, React__default.createElement("g", null, React__default.createElement("path", {
    fill: "#ffffff",
    d: "M617.2,495.8l349.1,350.9c31.7,31.8,31.7,83.5,0,115.3c-31.7,31.9-83.1,31.9-114.8,0L502.4,611.2L149.8,965.6c-32,32.2-83.8,32.2-115.8,0c-32-32.1-32-84.3,0-116.4l352.6-354.5L48.2,154.6c-31.7-31.9-31.7-83.5,0-115.4c31.7-31.9,83.1-31.9,114.7,0l338.4,340.2l343.3-345c32-32.1,83.8-32.1,115.8,0c32,32.2,32,84.3,0,116.4L617.2,495.8z"
  })));
};

var Message = function Message(_ref) {
  var type = _ref.type,
    text = _ref.text,
    onClose = _ref.onClose;
  if (text.trim()) {
    return React__default.createElement(StyledMessageWrapper, {
      type: type
    }, React__default.createElement(StyledFlex, {
      alignItems: "center",
      justifyContent: "space-between"
    }, React__default.createElement("div", {
      style: {
        flex: 1
      }
    }, capitalizeFirstLetter(text)), onClose && React__default.createElement("span", {
      style: {
        cursor: 'pointer'
      },
      onClick: onClose
    }, React__default.createElement(IconClose, null))));
  }
  return null;
};

var PasswordStrengthIndicator = function PasswordStrengthIndicator(_ref) {
  var value = _ref.value,
    setDisableButton = _ref.setDisableButton;
  var _React$useState = React__default.useState(_extends({}, validatePassword(value || ''))),
    _React$useState$ = _React$useState[0],
    strength = _React$useState$.strength,
    score = _React$useState$.score,
    hasSixChar = _React$useState$.hasSixChar,
    hasLowerCase = _React$useState$.hasLowerCase,
    hasNumericChar = _React$useState$.hasNumericChar,
    hasSpecialChar = _React$useState$.hasSpecialChar,
    hasUpperCase = _React$useState$.hasUpperCase,
    maxThirtySixChar = _React$useState$.maxThirtySixChar,
    setValidations = _React$useState[1];
  React__default.useEffect(function () {
    var validationData = validatePassword(value || '');
    setValidations(_extends({}, validationData));
    if (!validationData.isValid) {
      setDisableButton(true);
    } else {
      setDisableButton(false);
    }
  }, [value]);
  return React__default.createElement("div", null, React__default.createElement(StyledPasswordStrengthWrapper, null, React__default.createElement(StyledFlex, {
    alignItems: "center",
    justifyContent: "center",
    wrap: "nowrap"
  }, React__default.createElement(StyledPasswordStrength, {
    strength: score > 2 ? "weak" : "default"
  }), React__default.createElement(StyledPasswordStrength, {
    strength: score > 3 ? "good" : "default"
  }), React__default.createElement(StyledPasswordStrength, {
    strength: score > 4 ? "strong" : "default"
  }), React__default.createElement(StyledPasswordStrength, {
    strength: score > 5 ? "veryStrong" : "default"
  }), !!score && React__default.createElement("div", null, strength))), React__default.createElement("p", null, React__default.createElement("b", null, "Criteria for a strong password:")), React__default.createElement(StyledFlex, {
    flexDirection: "column"
  }, React__default.createElement(StyledFlex, {
    justifyContent: "flex-start",
    alignItems: "center",
    width: "100%"
  }, React__default.createElement("input", {
    readOnly: true,
    type: "checkbox",
    checked: hasSixChar
  }), React__default.createElement("div", {
    style: {
      marginLeft: '5px'
    }
  }, "At least 6 characters")), React__default.createElement(StyledFlex, {
    justifyContent: "flex-start",
    alignItems: "center",
    width: "100%"
  }, React__default.createElement("input", {
    readOnly: true,
    type: "checkbox",
    checked: hasLowerCase
  }), React__default.createElement("div", {
    style: {
      marginLeft: '5px'
    }
  }, "At least 1 lowercase letter")), React__default.createElement(StyledFlex, {
    justifyContent: "flex-start",
    alignItems: "center",
    width: "100%"
  }, React__default.createElement("input", {
    readOnly: true,
    type: "checkbox",
    checked: hasUpperCase
  }), React__default.createElement("div", {
    style: {
      marginLeft: '5px'
    }
  }, "At least 1 uppercase letter")), React__default.createElement(StyledFlex, {
    justifyContent: "flex-start",
    alignItems: "center",
    width: "100%"
  }, React__default.createElement("input", {
    readOnly: true,
    type: "checkbox",
    checked: hasNumericChar
  }), React__default.createElement("div", {
    style: {
      marginLeft: '5px'
    }
  }, "At least 1 numeric character")), React__default.createElement(StyledFlex, {
    justifyContent: "flex-start",
    alignItems: "center",
    width: "100%"
  }, React__default.createElement("input", {
    readOnly: true,
    type: "checkbox",
    checked: hasSpecialChar
  }), React__default.createElement("div", {
    style: {
      marginLeft: '5px'
    }
  }, "At least 1 special character")), React__default.createElement(StyledFlex, {
    justifyContent: "flex-start",
    alignItems: "center",
    width: "100%"
  }, React__default.createElement("input", {
    readOnly: true,
    type: "checkbox",
    checked: maxThirtySixChar
  }), React__default.createElement("div", {
    style: {
      marginLeft: '5px'
    }
  }, "Maximum 36 characters"))));
};

var AuthorizerSignup = function AuthorizerSignup(_ref) {
  var setView = _ref.setView,
    onSignup = _ref.onSignup,
    urlProps = _ref.urlProps,
    roles = _ref.roles;
  var _useState = React.useState(""),
    error = _useState[0],
    setError = _useState[1];
  var _useState2 = React.useState(false),
    loading = _useState2[0],
    setLoading = _useState2[1];
  var _useState3 = React.useState(""),
    successMessage = _useState3[0],
    setSuccessMessage = _useState3[1];
  var _useState4 = React.useState({
      email: null,
      password: null,
      confirmPassword: null
    }),
    formData = _useState4[0],
    setFormData = _useState4[1];
  var _useState5 = React.useState({
      email: null,
      password: null,
      confirmPassword: null
    }),
    errorData = _useState5[0],
    setErrorData = _useState5[1];
  var _useAuthorizer = useAuthorizer(),
    authorizerRef = _useAuthorizer.authorizerRef,
    config = _useAuthorizer.config,
    setAuthData = _useAuthorizer.setAuthData;
  var _useState6 = React.useState(false),
    disableSignupButton = _useState6[0],
    setDisableSignupButton = _useState6[1];
  var onInputChange = /*#__PURE__*/function () {
    var _ref2 = _asyncToGenerator( /*#__PURE__*/runtime_1.mark(function _callee(field, value) {
      var _extends2;
      return runtime_1.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              setFormData(_extends({}, formData, (_extends2 = {}, _extends2[field] = value, _extends2)));
            case 1:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));
    return function onInputChange(_x, _x2) {
      return _ref2.apply(this, arguments);
    };
  }();
  var onSubmit = /*#__PURE__*/function () {
    var _ref3 = _asyncToGenerator( /*#__PURE__*/runtime_1.mark(function _callee2(e) {
      var data, res;
      return runtime_1.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              e.preventDefault();
              _context2.prev = 1;
              setLoading(true);
              data = {
                email: formData.email || '',
                password: formData.password || '',
                confirm_password: formData.confirmPassword || ''
              };
              if (urlProps != null && urlProps.scope) {
                data.scope = urlProps.scope;
              }
              if (urlProps != null && urlProps.roles) {
                data.roles = urlProps.roles;
              }
              if (urlProps != null && urlProps.redirect_uri) {
                data.redirect_uri = urlProps.redirect_uri;
              }
              if (urlProps != null && urlProps.state) {
                data.state = urlProps.state;
              }
              if (roles && roles.length) {
                data.roles = roles;
              }
              _context2.next = 11;
              return authorizerRef.signup(data);
            case 11:
              res = _context2.sent;
              if (res) {
                setError("");
                if (res.access_token) {
                  setError("");
                  setAuthData({
                    user: res.user || null,
                    token: {
                      access_token: res.access_token,
                      expires_in: res.expires_in,
                      refresh_token: res.refresh_token,
                      id_token: res.id_token
                    },
                    config: config,
                    loading: false
                  });
                } else {
                  setLoading(false);
                  setSuccessMessage(res.message || "");
                }
                if (onSignup) {
                  onSignup(res);
                }
              }
              _context2.next = 19;
              break;
            case 15:
              _context2.prev = 15;
              _context2.t0 = _context2["catch"](1);
              setLoading(false);
              setError(formatErrorMessage(_context2.t0.message));
            case 19:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, null, [[1, 15]]);
    }));
    return function onSubmit(_x3) {
      return _ref3.apply(this, arguments);
    };
  }();
  var onErrorClose = function onErrorClose() {
    setError("");
  };
  React.useEffect(function () {
    if (formData.email === '') {
      setErrorData(_extends({}, errorData, {
        email: 'Email is required'
      }));
    } else if (formData.email && !isValidEmail(formData.email)) {
      setErrorData(_extends({}, errorData, {
        email: 'Please enter valid email'
      }));
    } else {
      setErrorData(_extends({}, errorData, {
        email: null
      }));
    }
  }, [formData.email]);
  React.useEffect(function () {
    if (formData.password === '') {
      setErrorData(_extends({}, errorData, {
        password: 'Password is required'
      }));
    } else {
      setErrorData(_extends({}, errorData, {
        password: null
      }));
    }
  }, [formData.password]);
  React.useEffect(function () {
    if (formData.confirmPassword === '') {
      setErrorData(_extends({}, errorData, {
        confirmPassword: 'Confirm password is required'
      }));
    } else {
      setErrorData(_extends({}, errorData, {
        confirmPassword: null
      }));
    }
  }, [formData.confirmPassword]);
  React.useEffect(function () {
    if (formData.password && formData.confirmPassword) {
      if (formData.confirmPassword !== formData.password) {
        setErrorData(_extends({}, errorData, {
          password: "Password and confirm passwords don't match",
          confirmPassword: "Password and confirm passwords don't match"
        }));
      } else {
        setErrorData(_extends({}, errorData, {
          password: null,
          confirmPassword: null
        }));
      }
    }
  }, [formData.password, formData.confirmPassword]);
  if (successMessage) {
    return React__default.createElement(Message, {
      type: MessageType.Success,
      text: successMessage
    });
  }
  return React__default.createElement(React__default.Fragment, null, error && React__default.createElement(Message, {
    type: MessageType.Error,
    text: error,
    onClose: onErrorClose
  }), config.is_basic_authentication_enabled && !config.is_magic_link_login_enabled && React__default.createElement(React__default.Fragment, null, React__default.createElement("form", {
    onSubmit: onSubmit,
    name: "authorizer-sign-up-form"
  }, React__default.createElement("div", {
    className: styles['styled-form-group']
  }, React__default.createElement("label", {
    className: styles['form-input-label'],
    htmlFor: "authorizer-sign-up-email"
  }, React__default.createElement("span", null, "* "), "Email"), React__default.createElement("input", {
    name: "email",
    id: "authorizer-sign-up-email",
    className: styles['form-input-field'] + " " + (errorData.email ? styles['input-error-content'] : null),
    placeholder: "eg. foo@bar.com",
    type: "email",
    value: formData.email || '',
    onChange: function onChange(e) {
      return onInputChange('email', e.target.value);
    }
  }), errorData.email && React__default.createElement("div", {
    className: styles['form-input-error']
  }, errorData.email)), React__default.createElement("div", {
    className: styles['styled-form-group']
  }, React__default.createElement("label", {
    className: styles['form-input-label'],
    htmlFor: "authorizer-sign-up-password"
  }, React__default.createElement("span", null, "* "), "Password"), React__default.createElement("input", {
    name: "password",
    id: "authorizer-sign-up-password",
    className: styles['form-input-field'] + " " + (errorData.password ? styles['input-error-content'] : null),
    placeholder: "********",
    type: "password",
    value: formData.password || '',
    onChange: function onChange(e) {
      return onInputChange('password', e.target.value);
    }
  }), errorData.password && React__default.createElement("div", {
    className: styles['form-input-error']
  }, errorData.password)), React__default.createElement("div", {
    className: styles['styled-form-group']
  }, React__default.createElement("label", {
    className: styles['form-input-label'],
    htmlFor: "authorizer-sign-up-confirm-password"
  }, React__default.createElement("span", null, "* "), "Confirm Password"), React__default.createElement("input", {
    name: "confirmPassword",
    id: "authorizer-sign-up-confirm-password",
    className: styles['form-input-field'] + " " + (errorData.confirmPassword ? styles['input-error-content'] : null),
    placeholder: "********",
    type: "password",
    value: formData.confirmPassword || '',
    onChange: function onChange(e) {
      return onInputChange('confirmPassword', e.target.value);
    }
  }), errorData.confirmPassword && React__default.createElement("div", {
    className: styles['form-input-error']
  }, errorData.confirmPassword)), config.is_strong_password_enabled && React__default.createElement(React__default.Fragment, null, React__default.createElement(PasswordStrengthIndicator, {
    value: formData.password || '',
    setDisableButton: setDisableSignupButton
  }), React__default.createElement("br", null)), React__default.createElement("br", null), React__default.createElement(StyledButton, {
    type: "submit",
    disabled: loading || disableSignupButton || !!errorData.email || !!errorData.password || !!errorData.confirmPassword || !formData.email || !formData.password || !formData.confirmPassword,
    appearance: ButtonAppearance.Primary
  }, loading ? "Processing ..." : "Sign Up")), setView && React__default.createElement(StyledFooter, null, React__default.createElement("div", null, "Already have an account?", ' ', React__default.createElement(StyledLink, {
    onClick: function onClick() {
      return setView(Views.Login);
    }
  }, "Log In")))));
};

var AuthorizerVerifyOtp = function AuthorizerVerifyOtp(_ref) {
  var setView = _ref.setView,
    onLogin = _ref.onLogin,
    email = _ref.email,
    urlProps = _ref.urlProps;
  var _useState = React.useState(""),
    error = _useState[0],
    setError = _useState[1];
  var _useState2 = React.useState(""),
    successMessage = _useState2[0],
    setSuccessMessage = _useState2[1];
  var _useState3 = React.useState(false),
    loading = _useState3[0],
    setLoading = _useState3[1];
  var _useState4 = React.useState(false),
    sendingOtp = _useState4[0],
    setSendingOtp = _useState4[1];
  var _useState5 = React.useState({
      otp: null
    }),
    formData = _useState5[0],
    setFormData = _useState5[1];
  var _useState6 = React.useState({
      otp: null
    }),
    errorData = _useState6[0],
    setErrorData = _useState6[1];
  var _useAuthorizer = useAuthorizer(),
    authorizerRef = _useAuthorizer.authorizerRef,
    config = _useAuthorizer.config,
    setAuthData = _useAuthorizer.setAuthData;
  var onInputChange = /*#__PURE__*/function () {
    var _ref2 = _asyncToGenerator( /*#__PURE__*/runtime_1.mark(function _callee(field, value) {
      var _extends2;
      return runtime_1.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              setFormData(_extends({}, formData, (_extends2 = {}, _extends2[field] = value, _extends2)));
            case 1:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));
    return function onInputChange(_x, _x2) {
      return _ref2.apply(this, arguments);
    };
  }();
  var onSubmit = /*#__PURE__*/function () {
    var _ref3 = _asyncToGenerator( /*#__PURE__*/runtime_1.mark(function _callee2(e) {
      var data, res;
      return runtime_1.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              e.preventDefault();
              setSuccessMessage("");
              _context2.prev = 2;
              setLoading(true);
              data = {
                email: email,
                otp: formData.otp || ''
              };
              if (urlProps != null && urlProps.state) {
                data.state = urlProps.state;
              }
              _context2.next = 8;
              return authorizerRef.verifyOtp(data);
            case 8:
              res = _context2.sent;
              setLoading(false);
              if (res) {
                setError("");
                setAuthData({
                  user: res.user || null,
                  token: {
                    access_token: res.access_token,
                    expires_in: res.expires_in,
                    refresh_token: res.refresh_token,
                    id_token: res.id_token
                  },
                  config: config,
                  loading: false
                });
              }
              if (onLogin) {
                onLogin(res);
              }
              _context2.next = 18;
              break;
            case 14:
              _context2.prev = 14;
              _context2.t0 = _context2["catch"](2);
              setLoading(false);
              setError(_context2.t0.message);
            case 18:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, null, [[2, 14]]);
    }));
    return function onSubmit(_x3) {
      return _ref3.apply(this, arguments);
    };
  }();
  var onErrorClose = function onErrorClose() {
    setError("");
  };
  var onSuccessClose = function onSuccessClose() {
    setSuccessMessage("");
  };
  var resendOtp = /*#__PURE__*/function () {
    var _ref4 = _asyncToGenerator( /*#__PURE__*/runtime_1.mark(function _callee3() {
      var res;
      return runtime_1.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              setSuccessMessage("");
              _context3.prev = 1;
              setSendingOtp(true);
              _context3.next = 5;
              return authorizerRef.resendOtp({
                email: email
              });
            case 5:
              res = _context3.sent;
              setSendingOtp(false);
              if (res && res != null && res.message) {
                setError("");
                setSuccessMessage(res.message);
              }
              if (onLogin) {
                onLogin(res);
              }
              _context3.next = 15;
              break;
            case 11:
              _context3.prev = 11;
              _context3.t0 = _context3["catch"](1);
              setLoading(false);
              setError(_context3.t0.message);
            case 15:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3, null, [[1, 11]]);
    }));
    return function resendOtp() {
      return _ref4.apply(this, arguments);
    };
  }();
  React.useEffect(function () {
    if (formData.otp === '') {
      setErrorData(_extends({}, errorData, {
        otp: 'OTP is required'
      }));
    } else if (formData.otp && !isValidOtp(formData.otp)) {
      setErrorData(_extends({}, errorData, {
        otp: 'Please enter valid OTP'
      }));
    } else {
      setErrorData(_extends({}, errorData, {
        otp: null
      }));
    }
  }, [formData.otp]);
  return React__default.createElement(React__default.Fragment, null, successMessage && React__default.createElement(Message, {
    type: MessageType.Success,
    text: successMessage,
    onClose: onSuccessClose
  }), error && React__default.createElement(Message, {
    type: MessageType.Error,
    text: error,
    onClose: onErrorClose
  }), React__default.createElement("p", {
    style: {
      textAlign: 'center',
      margin: '10px 0px'
    }
  }, "Please enter the OTP you received on your email address."), React__default.createElement("br", null), React__default.createElement("form", {
    onSubmit: onSubmit,
    name: "authorizer-mfa-otp-form"
  }, React__default.createElement("div", {
    className: styles['styled-form-group']
  }, React__default.createElement("label", {
    className: styles['form-input-label'],
    htmlFor: "authorizer-verify-otp"
  }, React__default.createElement("span", null, "* "), "OTP (One Time Password)"), React__default.createElement("input", {
    name: "otp",
    id: "authorizer-verify-otp",
    className: styles['form-input-field'] + " " + (errorData.otp ? styles['input-error-content'] : null),
    placeholder: "e.g.- AB123C",
    type: "password",
    value: formData.otp || '',
    onChange: function onChange(e) {
      return onInputChange('otp', e.target.value);
    }
  }), errorData.otp && React__default.createElement("div", {
    className: styles['form-input-error']
  }, errorData.otp)), React__default.createElement("br", null), React__default.createElement(StyledButton, {
    type: "submit",
    disabled: loading || !formData.otp || !!errorData.otp,
    appearance: ButtonAppearance.Primary
  }, loading ? "Processing ..." : "Submit")), setView && React__default.createElement(StyledFooter, null, sendingOtp ? React__default.createElement("div", {
    style: {
      marginBottom: '10px'
    }
  }, "Sending ...") : React__default.createElement(StyledLink, {
    onClick: resendOtp,
    marginBottom: "10px"
  }, "Resend OTP"), config.is_sign_up_enabled && React__default.createElement("div", null, "Don't have an account?", ' ', React__default.createElement(StyledLink, {
    onClick: function onClick() {
      return setView(Views.Signup);
    }
  }, "Sign Up"))));
};

var initOtpData = {
  isScreenVisible: false,
  email: ''
};
var AuthorizerBasicAuthLogin = function AuthorizerBasicAuthLogin(_ref) {
  var setView = _ref.setView,
    onLogin = _ref.onLogin,
    urlProps = _ref.urlProps,
    roles = _ref.roles;
  var _useState = React.useState(""),
    error = _useState[0],
    setError = _useState[1];
  var _useState2 = React.useState(false),
    loading = _useState2[0],
    setLoading = _useState2[1];
  var _useState3 = React.useState(_extends({}, initOtpData)),
    otpData = _useState3[0],
    setOtpData = _useState3[1];
  var _useState4 = React.useState({
      email: null,
      password: null
    }),
    formData = _useState4[0],
    setFormData = _useState4[1];
  var _useState5 = React.useState({
      email: null,
      password: null
    }),
    errorData = _useState5[0],
    setErrorData = _useState5[1];
  var _useAuthorizer = useAuthorizer(),
    setAuthData = _useAuthorizer.setAuthData,
    config = _useAuthorizer.config,
    authorizerRef = _useAuthorizer.authorizerRef;
  var onInputChange = /*#__PURE__*/function () {
    var _ref2 = _asyncToGenerator( /*#__PURE__*/runtime_1.mark(function _callee(field, value) {
      var _extends2;
      return runtime_1.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              setFormData(_extends({}, formData, (_extends2 = {}, _extends2[field] = value, _extends2)));
            case 1:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));
    return function onInputChange(_x, _x2) {
      return _ref2.apply(this, arguments);
    };
  }();
  var onSubmit = /*#__PURE__*/function () {
    var _ref3 = _asyncToGenerator( /*#__PURE__*/runtime_1.mark(function _callee2(e) {
      var data, res;
      return runtime_1.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              e.preventDefault();
              setLoading(true);
              _context2.prev = 2;
              data = {
                email: formData.email || '',
                password: formData.password || ''
              };
              if (urlProps != null && urlProps.scope) {
                data.scope = urlProps.scope;
              }
              if (urlProps != null && urlProps.state) {
                data.state = urlProps.state;
              }
              if (roles && roles.length) {
                data.roles = roles;
              }
              _context2.next = 9;
              return authorizerRef.login(data);
            case 9:
              res = _context2.sent;
              if (!(res && res != null && res.should_show_otp_screen)) {
                _context2.next = 13;
                break;
              }
              setOtpData({
                isScreenVisible: true,
                email: data.email
              });
              return _context2.abrupt("return");
            case 13:
              if (res) {
                setError("");
                setAuthData({
                  user: res.user || null,
                  token: {
                    access_token: res.access_token,
                    expires_in: res.expires_in,
                    refresh_token: res.refresh_token,
                    id_token: res.id_token
                  },
                  config: config,
                  loading: false
                });
              }
              if (onLogin) {
                onLogin(res);
              }
              _context2.next = 21;
              break;
            case 17:
              _context2.prev = 17;
              _context2.t0 = _context2["catch"](2);
              setLoading(false);
              setError(_context2.t0.message);
            case 21:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, null, [[2, 17]]);
    }));
    return function onSubmit(_x3) {
      return _ref3.apply(this, arguments);
    };
  }();
  var onErrorClose = function onErrorClose() {
    setError("");
  };
  React.useEffect(function () {
    if (formData.email === '') {
      setErrorData(_extends({}, errorData, {
        email: 'Email is required'
      }));
    } else if (formData.email && !isValidEmail(formData.email)) {
      setErrorData(_extends({}, errorData, {
        email: 'Please enter valid email'
      }));
    } else {
      setErrorData(_extends({}, errorData, {
        email: null
      }));
    }
  }, [formData.email]);
  React.useEffect(function () {
    if (formData.password === '') {
      setErrorData(_extends({}, errorData, {
        password: 'Password is required'
      }));
    } else {
      setErrorData(_extends({}, errorData, {
        password: null
      }));
    }
  }, [formData.password]);
  return otpData.isScreenVisible ? React__default.createElement(AuthorizerVerifyOtp, Object.assign({}, {
    setView: setView,
    onLogin: onLogin,
    email: otpData.email
  }, {
    urlProps: urlProps
  })) : React__default.createElement(React__default.Fragment, null, error && React__default.createElement(Message, {
    type: MessageType.Error,
    text: error,
    onClose: onErrorClose
  }), React__default.createElement(React__default.Fragment, null, React__default.createElement("form", {
    onSubmit: onSubmit,
    name: "authorizer-login-form"
  }, React__default.createElement("div", {
    className: styles['styled-form-group']
  }, React__default.createElement("label", {
    className: styles['form-input-label'],
    htmlFor: "authorizer-login-email"
  }, React__default.createElement("span", null, "* "), "Email"), React__default.createElement("input", {
    name: "email",
    id: "authorizer-login-email",
    className: styles['form-input-field'] + " " + (errorData.email ? styles['input-error-content'] : null),
    placeholder: "eg. foo@bar.com",
    type: "email",
    value: formData.email || '',
    onChange: function onChange(e) {
      return onInputChange('email', e.target.value);
    }
  }), errorData.email && React__default.createElement("div", {
    className: styles['form-input-error']
  }, errorData.email)), React__default.createElement("div", {
    className: styles['styled-form-group']
  }, React__default.createElement("label", {
    className: styles['form-input-label'],
    htmlFor: "authorizer-login-password"
  }, React__default.createElement("span", null, "* "), "Password"), React__default.createElement("input", {
    name: "password",
    id: "authorizer-login-password",
    className: styles['form-input-field'] + " " + (errorData.password ? styles['input-error-content'] : null),
    placeholder: "********",
    type: "password",
    value: formData.password || '',
    onChange: function onChange(e) {
      return onInputChange('password', e.target.value);
    }
  }), errorData.password && React__default.createElement("div", {
    className: styles['form-input-error']
  }, errorData.password)), React__default.createElement("br", null), React__default.createElement(StyledButton, {
    type: "submit",
    disabled: !!errorData.email || !!errorData.password || !formData.email || !formData.password || loading,
    appearance: ButtonAppearance.Primary
  }, loading ? "Processing ..." : "Log In")), setView && React__default.createElement(StyledFooter, null, React__default.createElement(StyledLink, {
    onClick: function onClick() {
      return setView(Views.ForgotPassword);
    },
    marginBottom: "10px"
  }, "Forgot Password?"), config.is_sign_up_enabled && React__default.createElement("div", null, "Don't have an account?", ' ', React__default.createElement(StyledLink, {
    onClick: function onClick() {
      return setView(Views.Signup);
    }
  }, "Sign Up")))));
};

var AuthorizerMagicLinkLogin = function AuthorizerMagicLinkLogin(_ref) {
  var onMagicLinkLogin = _ref.onMagicLinkLogin,
    urlProps = _ref.urlProps,
    roles = _ref.roles;
  var _useState = React.useState(""),
    error = _useState[0],
    setError = _useState[1];
  var _useState2 = React.useState(false),
    loading = _useState2[0],
    setLoading = _useState2[1];
  var _useState3 = React.useState(""),
    successMessage = _useState3[0],
    setSuccessMessage = _useState3[1];
  var _useState4 = React.useState({
      email: null
    }),
    formData = _useState4[0],
    setFormData = _useState4[1];
  var _useState5 = React.useState({
      email: null
    }),
    errorData = _useState5[0],
    setErrorData = _useState5[1];
  var _useAuthorizer = useAuthorizer(),
    authorizerRef = _useAuthorizer.authorizerRef;
  var onInputChange = /*#__PURE__*/function () {
    var _ref2 = _asyncToGenerator( /*#__PURE__*/runtime_1.mark(function _callee(field, value) {
      var _extends2;
      return runtime_1.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              setFormData(_extends({}, formData, (_extends2 = {}, _extends2[field] = value, _extends2)));
            case 1:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));
    return function onInputChange(_x, _x2) {
      return _ref2.apply(this, arguments);
    };
  }();
  var onSubmit = /*#__PURE__*/function () {
    var _ref3 = _asyncToGenerator( /*#__PURE__*/runtime_1.mark(function _callee2(e) {
      var data, res;
      return runtime_1.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              e.preventDefault();
              _context2.prev = 1;
              setLoading(true);
              data = {
                email: formData.email || '',
                state: (urlProps == null ? void 0 : urlProps.state) || '',
                redirect_uri: (urlProps == null ? void 0 : urlProps.redirect_uri) || ''
              };
              if (roles && roles.length) {
                data.roles = roles;
              }
              _context2.next = 7;
              return authorizerRef.magicLinkLogin(data);
            case 7:
              res = _context2.sent;
              setLoading(false);
              if (res) {
                setError("");
                setSuccessMessage(res.message || "");
                if (onMagicLinkLogin) {
                  onMagicLinkLogin(res);
                }
              }
              if (urlProps != null && urlProps.redirect_uri) {
                setTimeout(function () {
                  window.location.replace(urlProps.redirect_uri);
                }, 3000);
              }
              _context2.next = 17;
              break;
            case 13:
              _context2.prev = 13;
              _context2.t0 = _context2["catch"](1);
              setLoading(false);
              setError(formatErrorMessage(_context2.t0 == null ? void 0 : _context2.t0.message));
            case 17:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, null, [[1, 13]]);
    }));
    return function onSubmit(_x3) {
      return _ref3.apply(this, arguments);
    };
  }();
  var onErrorClose = function onErrorClose() {
    setError("");
  };
  React.useEffect(function () {
    if (formData.email === '') {
      setErrorData(_extends({}, errorData, {
        email: 'Email is required'
      }));
    } else if (formData.email && !isValidEmail(formData.email)) {
      setErrorData(_extends({}, errorData, {
        email: 'Please enter valid email'
      }));
    } else {
      setErrorData(_extends({}, errorData, {
        email: null
      }));
    }
  }, [formData.email]);
  if (successMessage) {
    return React__default.createElement(Message, {
      type: MessageType.Success,
      text: successMessage
    });
  }
  return React__default.createElement(React__default.Fragment, null, error && React__default.createElement(Message, {
    type: MessageType.Error,
    text: error,
    onClose: onErrorClose
  }), React__default.createElement("form", {
    onSubmit: onSubmit,
    name: "authorizer-magic-login-form"
  }, React__default.createElement("div", {
    className: styles['styled-form-group']
  }, React__default.createElement("label", {
    className: styles['form-input-label'],
    htmlFor: "authorizer-magic-link-login-email"
  }, React__default.createElement("span", null, "* "), "Email"), React__default.createElement("input", {
    name: "email",
    id: "authorizer-magic-link-login-email",
    className: styles['form-input-field'] + " " + (errorData.email ? styles['input-error-content'] : null),
    placeholder: "eg. foo@bar.com",
    type: "email",
    value: formData.email || '',
    onChange: function onChange(e) {
      return onInputChange('email', e.target.value);
    }
  }), errorData.email && React__default.createElement("div", {
    className: styles['form-input-error']
  }, errorData.email)), React__default.createElement("br", null), React__default.createElement(StyledButton, {
    type: "submit",
    disabled: loading || !!errorData.email || !formData.email,
    appearance: ButtonAppearance.Primary
  }, loading ? "Processing ..." : "Send Email")));
};

var AuthorizerForgotPassword = function AuthorizerForgotPassword(_ref) {
  var setView = _ref.setView,
    onForgotPassword = _ref.onForgotPassword,
    urlProps = _ref.urlProps;
  var _useState = React.useState(""),
    error = _useState[0],
    setError = _useState[1];
  var _useState2 = React.useState(false),
    loading = _useState2[0],
    setLoading = _useState2[1];
  var _useState3 = React.useState(""),
    successMessage = _useState3[0],
    setSuccessMessage = _useState3[1];
  var _useState4 = React.useState({
      email: null
    }),
    formData = _useState4[0],
    setFormData = _useState4[1];
  var _useState5 = React.useState({
      email: null
    }),
    errorData = _useState5[0],
    setErrorData = _useState5[1];
  var _useAuthorizer = useAuthorizer(),
    authorizerRef = _useAuthorizer.authorizerRef,
    config = _useAuthorizer.config;
  var onInputChange = /*#__PURE__*/function () {
    var _ref2 = _asyncToGenerator( /*#__PURE__*/runtime_1.mark(function _callee(field, value) {
      var _extends2;
      return runtime_1.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              setFormData(_extends({}, formData, (_extends2 = {}, _extends2[field] = value, _extends2)));
            case 1:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));
    return function onInputChange(_x, _x2) {
      return _ref2.apply(this, arguments);
    };
  }();
  var onSubmit = /*#__PURE__*/function () {
    var _ref3 = _asyncToGenerator( /*#__PURE__*/runtime_1.mark(function _callee2(e) {
      var res;
      return runtime_1.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              e.preventDefault();
              _context2.prev = 1;
              setLoading(true);
              _context2.next = 5;
              return authorizerRef.forgotPassword({
                email: formData.email || '',
                state: (urlProps == null ? void 0 : urlProps.state) || '',
                redirect_uri: (urlProps == null ? void 0 : urlProps.redirect_uri) || config.redirectURL || window.location.origin
              });
            case 5:
              res = _context2.sent;
              setLoading(false);
              if (res && res.message) {
                setError("");
                setSuccessMessage(res.message);
              }
              if (onForgotPassword) {
                onForgotPassword(res);
              }
              _context2.next = 15;
              break;
            case 11:
              _context2.prev = 11;
              _context2.t0 = _context2["catch"](1);
              setLoading(false);
              setError(formatErrorMessage(_context2.t0 == null ? void 0 : _context2.t0.message));
            case 15:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, null, [[1, 11]]);
    }));
    return function onSubmit(_x3) {
      return _ref3.apply(this, arguments);
    };
  }();
  var onErrorClose = function onErrorClose() {
    setError("");
  };
  React.useEffect(function () {
    if (formData.email === '') {
      setErrorData(_extends({}, errorData, {
        email: 'Email is required'
      }));
    } else if (formData.email && !isValidEmail(formData.email)) {
      setErrorData(_extends({}, errorData, {
        email: 'Please enter valid email'
      }));
    } else {
      setErrorData(_extends({}, errorData, {
        email: null
      }));
    }
  }, [formData.email]);
  if (successMessage) {
    return React__default.createElement(Message, {
      type: MessageType.Success,
      text: successMessage
    });
  }
  return React__default.createElement(React__default.Fragment, null, error && React__default.createElement(Message, {
    type: MessageType.Error,
    text: error,
    onClose: onErrorClose
  }), React__default.createElement("p", {
    style: {
      textAlign: 'center',
      margin: '10px 0px'
    }
  }, "Please enter your email address.", React__default.createElement("br", null), " We will send you an email to reset your password."), React__default.createElement("br", null), React__default.createElement("form", {
    onSubmit: onSubmit,
    name: "authorizer-forgot-password-form"
  }, React__default.createElement("div", {
    className: styles['styled-form-group']
  }, React__default.createElement("label", {
    className: styles['form-input-label'],
    htmlFor: "authorizer-forgot-password-email"
  }, React__default.createElement("span", null, "* "), "Email"), React__default.createElement("input", {
    name: "email",
    id: "authorizer-forgot-password-email",
    className: styles['form-input-field'] + " " + (errorData.email ? styles['input-error-content'] : null),
    placeholder: "eg. foo@bar.com",
    type: "email",
    value: formData.email || '',
    onChange: function onChange(e) {
      return onInputChange('email', e.target.value);
    }
  }), errorData.email && React__default.createElement("div", {
    className: styles['form-input-error']
  }, errorData.email)), React__default.createElement("br", null), React__default.createElement(StyledButton, {
    type: "submit",
    disabled: loading || !!errorData.email || !formData.email,
    appearance: ButtonAppearance.Primary
  }, loading ? "Processing ..." : "Send Email")), setView && React__default.createElement(StyledFooter, null, React__default.createElement("div", null, "Remember your password?", ' ', React__default.createElement(StyledLink, {
    onClick: function onClick() {
      return setView(Views.Login);
    }
  }, "Log In"))));
};

var Github = function Github() {
  return React__default.createElement("div", {
    style: {
      position: 'absolute',
      left: '10px',
      top: '12px',
      display: 'flex'
    }
  }, React__default.createElement("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    viewBox: "0 0 291.32 291.32",
    width: "24px",
    height: "24px"
  }, React__default.createElement("path", {
    d: "M145.66 0C65.219 0 0 65.219 0 145.66c0 80.45 65.219 145.66 145.66 145.66s145.66-65.21 145.66-145.66C291.319 65.219 226.1 0 145.66 0zm40.802 256.625c-.838-11.398-1.775-25.518-1.83-31.235-.364-4.388-.838-15.549-11.434-22.677 42.068-3.523 62.087-26.774 63.526-57.499 1.202-17.497-5.754-32.883-18.107-45.3.628-13.282-.401-29.023-1.256-35.941-9.486-2.731-31.608 8.949-37.79 13.947-13.037-5.062-44.945-6.837-64.336 0-13.747-9.668-29.396-15.64-37.926-13.974-7.875 17.452-2.813 33.948-1.275 35.914-10.142 9.268-24.289 20.675-20.447 44.572 6.163 35.04 30.816 53.94 70.508 58.564-8.466 1.73-9.896 8.048-10.606 10.788-26.656 10.997-34.275-6.791-37.644-11.425-11.188-13.847-21.23-9.832-21.849-9.614-.601.218-1.056 1.092-.992 1.511.564 2.986 6.655 6.018 6.955 6.263 8.257 6.154 11.316 17.27 13.2 20.438 11.844 19.473 39.374 11.398 39.638 11.562.018 1.702-.191 16.032-.355 27.184C64.245 245.992 27.311 200.2 27.311 145.66c0-65.365 52.984-118.348 118.348-118.348S264.008 80.295 264.008 145.66c0 51.008-32.318 94.332-77.546 110.965z",
    fill: "#2b414d"
  })));
};

var Google = function Google() {
  return React__default.createElement("div", {
    style: {
      position: 'absolute',
      left: '10px',
      top: '12px',
      display: 'flex'
    }
  }, React__default.createElement("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    width: "24px",
    height: "24px"
  }, React__default.createElement("g", {
    transform: "matrix(1, 0, 0, 1, 27.009001, -39.238998)"
  }, React__default.createElement("path", {
    fill: "#4285F4",
    d: "M -3.264 51.509 C -3.264 50.719 -3.334 49.969 -3.454 49.239 L -14.754 49.239 L -14.754 53.749 L -8.284 53.749 C -8.574 55.229 -9.424 56.479 -10.684 57.329 L -10.684 60.329 L -6.824 60.329 C -4.564 58.239 -3.264 55.159 -3.264 51.509 Z"
  }), React__default.createElement("path", {
    fill: "#34A853",
    d: "M -14.754 63.239 C -11.514 63.239 -8.804 62.159 -6.824 60.329 L -10.684 57.329 C -11.764 58.049 -13.134 58.489 -14.754 58.489 C -17.884 58.489 -20.534 56.379 -21.484 53.529 L -25.464 53.529 L -25.464 56.619 C -23.494 60.539 -19.444 63.239 -14.754 63.239 Z"
  }), React__default.createElement("path", {
    fill: "#FBBC05",
    d: "M -21.484 53.529 C -21.734 52.809 -21.864 52.039 -21.864 51.239 C -21.864 50.439 -21.724 49.669 -21.484 48.949 L -21.484 45.859 L -25.464 45.859 C -26.284 47.479 -26.754 49.299 -26.754 51.239 C -26.754 53.179 -26.284 54.999 -25.464 56.619 L -21.484 53.529 Z"
  }), React__default.createElement("path", {
    fill: "#EA4335",
    d: "M -14.754 43.989 C -12.984 43.989 -11.404 44.599 -10.154 45.789 L -6.734 42.369 C -8.804 40.429 -11.514 39.239 -14.754 39.239 C -19.444 39.239 -23.494 41.939 -25.464 45.859 L -21.484 48.949 C -20.534 46.099 -17.884 43.989 -14.754 43.989 Z"
  }))));
};

var Facebook = function Facebook() {
  return React__default.createElement("div", {
    style: {
      position: 'absolute',
      left: '10px',
      top: '12px',
      display: 'flex'
    }
  }, React__default.createElement("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    viewBox: "0 0 50 50",
    width: "24px",
    height: "24px",
    fill: "#1877f2"
  }, React__default.createElement("path", {
    d: "M41,4H9C6.24,4,4,6.24,4,9v32c0,2.76,2.24,5,5,5h32c2.76,0,5-2.24,5-5V9C46,6.24,43.76,4,41,4z M37,19h-2c-2.14,0-3,0.5-3,2 v3h5l-1,5h-4v15h-5V29h-4v-5h4v-3c0-4,2-7,6-7c2.9,0,4,1,4,1V19z"
  })));
};

var getCrypto = function getCrypto() {
  //ie 11.x uses msCrypto
  return hasWindow() ? window.crypto || window.msCrypto : null;
};
var createRandomString = function createRandomString() {
  var charset = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz-_~.';
  var random = '';
  var crypto = getCrypto();
  if (crypto) {
    var randomValues = Array.from(crypto.getRandomValues(new Uint8Array(43)));
    randomValues.forEach(function (v) {
      return random += charset[v % charset.length];
    });
  }
  return random;
};
var createQueryParams = function createQueryParams(params) {
  return Object.keys(params).filter(function (k) {
    return typeof params[k] !== 'undefined';
  }).map(function (k) {
    return encodeURIComponent(k) + '=' + encodeURIComponent(params[k]);
  }).join('&');
};

var LinkedIn = function LinkedIn() {
  return React__default.createElement("div", {
    style: {
      position: 'absolute',
      left: '8px',
      top: '7.5px',
      display: 'flex'
    }
  }, React__default.createElement("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    viewBox: "0 0 48 48",
    width: "32px",
    height: "32px"
  }, React__default.createElement("path", {
    fill: "#0288D1",
    d: "M42,37c0,2.762-2.238,5-5,5H11c-2.761,0-5-2.238-5-5V11c0-2.762,2.239-5,5-5h26c2.762,0,5,2.238,5,5V37z"
  }), React__default.createElement("path", {
    fill: "#FFF",
    d: "M12 19H17V36H12zM14.485 17h-.028C12.965 17 12 15.888 12 14.499 12 13.08 12.995 12 14.514 12c1.521 0 2.458 1.08 2.486 2.499C17 15.887 16.035 17 14.485 17zM36 36h-5v-9.099c0-2.198-1.225-3.698-3.192-3.698-1.501 0-2.313 1.012-2.707 1.99C24.957 25.543 25 26.511 25 27v9h-5V19h5v2.616C25.721 20.5 26.85 19 29.738 19c3.578 0 6.261 2.25 6.261 7.274L36 36 36 36z"
  })));
};

var Apple = function Apple() {
  return React__default.createElement("div", {
    style: {
      position: 'absolute',
      left: '10px',
      top: '10px',
      display: 'flex'
    }
  }, React__default.createElement("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    viewBox: "0 0 256 315",
    width: "24px",
    height: "24px"
  }, React__default.createElement("path", {
    d: "M213.803 167.03c.442 47.58 41.74 63.413 42.197 63.615-.35 1.116-6.599 22.563-21.757 44.716-13.104 19.153-26.705 38.235-48.13 38.63-21.05.388-27.82-12.483-51.888-12.483-24.061 0-31.582 12.088-51.51 12.871-20.68.783-36.428-20.71-49.64-39.793-27-39.033-47.633-110.3-19.928-158.406 13.763-23.89 38.36-39.017 65.056-39.405 20.307-.387 39.475 13.662 51.889 13.662 12.406 0 35.699-16.895 60.186-14.414 10.25.427 39.026 4.14 57.503 31.186-1.49.923-34.335 20.044-33.978 59.822M174.24 50.199c10.98-13.29 18.369-31.79 16.353-50.199-15.826.636-34.962 10.546-46.314 23.828-10.173 11.763-19.082 30.589-16.678 48.633 17.64 1.365 35.66-8.964 46.64-22.262"
  })));
};

var Twitter = function Twitter() {
  return React__default.createElement("div", {
    style: {
      position: 'absolute',
      left: '10px',
      top: '12px',
      display: 'flex'
    }
  }, React__default.createElement("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    viewBox: "0 0 48 48",
    width: "24px",
    height: "24px"
  }, React__default.createElement("path", {
    fill: "#03A9F4",
    d: "M42,12.429c-1.323,0.586-2.746,0.977-4.247,1.162c1.526-0.906,2.7-2.351,3.251-4.058c-1.428,0.837-3.01,1.452-4.693,1.776C34.967,9.884,33.05,9,30.926,9c-4.08,0-7.387,3.278-7.387,7.32c0,0.572,0.067,1.129,0.193,1.67c-6.138-0.308-11.582-3.226-15.224-7.654c-0.64,1.082-1,2.349-1,3.686c0,2.541,1.301,4.778,3.285,6.096c-1.211-0.037-2.351-0.374-3.349-0.914c0,0.022,0,0.055,0,0.086c0,3.551,2.547,6.508,5.923,7.181c-0.617,0.169-1.269,0.263-1.941,0.263c-0.477,0-0.942-0.054-1.392-0.135c0.94,2.902,3.667,5.023,6.898,5.086c-2.528,1.96-5.712,3.134-9.174,3.134c-0.598,0-1.183-0.034-1.761-0.104C9.268,36.786,13.152,38,17.321,38c13.585,0,21.017-11.156,21.017-20.834c0-0.317-0.01-0.633-0.025-0.945C39.763,15.197,41.013,13.905,42,12.429"
  })));
};

var Microsoft = function Microsoft() {
  return React__default.createElement("div", {
    style: {
      position: 'absolute',
      left: '10px',
      top: '12px',
      display: 'flex'
    }
  }, React__default.createElement("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    viewBox: "0 0 48 48",
    width: "24px",
    height: "24px"
  }, React__default.createElement("path", {
    fill: "#ff5722",
    d: "M6 6H22V22H6z",
    transform: "rotate(-180 14 14)"
  }), React__default.createElement("path", {
    fill: "#4caf50",
    d: "M26 6H42V22H26z",
    transform: "rotate(-180 34 14)"
  }), React__default.createElement("path", {
    fill: "#ffc107",
    d: "M26 26H42V42H26z",
    transform: "rotate(-180 34 34)"
  }), React__default.createElement("path", {
    fill: "#03a9f4",
    d: "M6 26H22V42H6z",
    transform: "rotate(-180 14 34)"
  })));
};

var AuthorizerSocialLogin = function AuthorizerSocialLogin(_ref) {
  var urlProps = _ref.urlProps,
    roles = _ref.roles;
  var _useAuthorizer = useAuthorizer(),
    config = _useAuthorizer.config;
  var hasSocialLogin = config.is_google_login_enabled || config.is_github_login_enabled || config.is_facebook_login_enabled || config.is_linkedin_login_enabled || config.is_apple_login_enabled || config.is_twitter_login_enabled || config.is_microsoft_login_enabled;
  var data = _extends({}, urlProps || {}, {
    scope: urlProps == null ? void 0 : urlProps.scope.join(' ')
  });
  if (roles && roles.length) {
    data.roles = roles;
  }
  var queryParams = createQueryParams(data);
  return React__default.createElement(React__default.Fragment, null, config.is_apple_login_enabled && React__default.createElement("div", {
    id: "appleid-signin"
  }, React__default.createElement(StyledButton, {
    appearance: ButtonAppearance.Default,
    onClick: function onClick() {
      window.location.href = config.authorizerURL + "/oauth_login/apple?" + queryParams;
    }
  }, React__default.createElement(Apple, null), "Continue with Apple"), React__default.createElement("br", null)), config.is_google_login_enabled && React__default.createElement(React__default.Fragment, null, React__default.createElement(StyledButton, {
    appearance: ButtonAppearance.Default,
    onClick: function onClick() {
      window.location.href = config.authorizerURL + "/oauth_login/google?" + queryParams;
    }
  }, React__default.createElement(Google, null), "Continue with Google"), React__default.createElement("br", null)), config.is_github_login_enabled && React__default.createElement(React__default.Fragment, null, React__default.createElement(StyledButton, {
    appearance: ButtonAppearance.Default,
    onClick: function onClick() {
      window.location.href = config.authorizerURL + "/oauth_login/github?" + queryParams;
    }
  }, React__default.createElement(Github, null), "Continue with Github"), React__default.createElement("br", null)), config.is_facebook_login_enabled && React__default.createElement(React__default.Fragment, null, React__default.createElement(StyledButton, {
    appearance: ButtonAppearance.Default,
    onClick: function onClick() {
      window.location.href = config.authorizerURL + "/oauth_login/facebook?" + queryParams;
    }
  }, React__default.createElement(Facebook, null), "Continue with Facebook"), React__default.createElement("br", null)), config.is_linkedin_login_enabled && React__default.createElement(React__default.Fragment, null, React__default.createElement(StyledButton, {
    appearance: ButtonAppearance.Default,
    onClick: function onClick() {
      window.location.href = config.authorizerURL + "/oauth_login/linkedin?" + queryParams;
    }
  }, React__default.createElement(LinkedIn, null), "Continue with LinkedIn"), React__default.createElement("br", null)), config.is_twitter_login_enabled && React__default.createElement(React__default.Fragment, null, React__default.createElement(StyledButton, {
    appearance: ButtonAppearance.Default,
    onClick: function onClick() {
      window.location.href = config.authorizerURL + "/oauth_login/twitter?" + queryParams;
    }
  }, React__default.createElement(Twitter, null), "Continue with Twitter"), React__default.createElement("br", null)), config.is_microsoft_login_enabled && React__default.createElement(React__default.Fragment, null, React__default.createElement(StyledButton, {
    appearance: ButtonAppearance.Default,
    onClick: function onClick() {
      window.location.href = config.authorizerURL + "/oauth_login/microsoft?" + queryParams;
    }
  }, React__default.createElement(Microsoft, null), "Continue with Microsoft"), React__default.createElement("br", null)), hasSocialLogin && (config.is_basic_authentication_enabled || config.is_magic_link_login_enabled) && React__default.createElement(StyledSeparator, null, "OR"));
};

var getSearchParams = function getSearchParams(search) {
  if (search === void 0) {
    search = '';
  }
  var searchPrams = search;
  if (!searchPrams && hasWindow()) {
    searchPrams = window.location.search;
  }
  var urlSearchParams = new URLSearchParams("" + searchPrams);
  // @ts-ignore
  var params = Object.fromEntries(urlSearchParams.entries());
  return params;
};

var AuthorizerResetPassword = function AuthorizerResetPassword(_ref) {
  var onReset = _ref.onReset;
  var _getSearchParams = getSearchParams(),
    token = _getSearchParams.token,
    redirect_uri = _getSearchParams.redirect_uri;
  var _useState = React.useState(!token ? "Invalid token" : ""),
    error = _useState[0],
    setError = _useState[1];
  var _useState2 = React.useState(false),
    loading = _useState2[0],
    setLoading = _useState2[1];
  var _useState3 = React.useState({
      password: null,
      confirmPassword: null
    }),
    formData = _useState3[0],
    setFormData = _useState3[1];
  var _useState4 = React.useState({
      password: null,
      confirmPassword: null
    }),
    errorData = _useState4[0],
    setErrorData = _useState4[1];
  var _useAuthorizer = useAuthorizer(),
    authorizerRef = _useAuthorizer.authorizerRef,
    config = _useAuthorizer.config;
  var _useState5 = React.useState(false),
    disableContinueButton = _useState5[0],
    setDisableContinueButton = _useState5[1];
  var onInputChange = /*#__PURE__*/function () {
    var _ref2 = _asyncToGenerator( /*#__PURE__*/runtime_1.mark(function _callee(field, value) {
      var _extends2;
      return runtime_1.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              setFormData(_extends({}, formData, (_extends2 = {}, _extends2[field] = value, _extends2)));
            case 1:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));
    return function onInputChange(_x, _x2) {
      return _ref2.apply(this, arguments);
    };
  }();
  var onSubmit = /*#__PURE__*/function () {
    var _ref3 = _asyncToGenerator( /*#__PURE__*/runtime_1.mark(function _callee2(e) {
      var res;
      return runtime_1.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              e.preventDefault();
              setLoading(true);
              _context2.prev = 2;
              _context2.next = 5;
              return authorizerRef.resetPassword({
                token: token,
                password: formData.password || '',
                confirm_password: formData.confirmPassword || ''
              });
            case 5:
              res = _context2.sent;
              setLoading(false);
              setError("");
              if (onReset) {
                onReset(res);
              } else {
                window.location.href = redirect_uri || config.redirectURL || window.location.origin;
              }
              _context2.next = 15;
              break;
            case 11:
              _context2.prev = 11;
              _context2.t0 = _context2["catch"](2);
              setLoading(false);
              setError(formatErrorMessage(_context2.t0.message));
            case 15:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, null, [[2, 11]]);
    }));
    return function onSubmit(_x3) {
      return _ref3.apply(this, arguments);
    };
  }();
  var onErrorClose = function onErrorClose() {
    setError("");
  };
  React.useEffect(function () {
    if (formData.password === '') {
      setErrorData(_extends({}, errorData, {
        password: 'Password is required'
      }));
    } else {
      setErrorData(_extends({}, errorData, {
        password: null
      }));
    }
  }, [formData.password]);
  React.useEffect(function () {
    if (formData.confirmPassword === '') {
      setErrorData(_extends({}, errorData, {
        confirmPassword: 'Confirm password is required'
      }));
    } else {
      setErrorData(_extends({}, errorData, {
        confirmPassword: null
      }));
    }
  }, [formData.confirmPassword]);
  React.useEffect(function () {
    if (formData.password && formData.confirmPassword) {
      if (formData.confirmPassword !== formData.password) {
        setErrorData(_extends({}, errorData, {
          password: "Password and confirm passwords don't match",
          confirmPassword: "Password and confirm passwords don't match"
        }));
      } else {
        setErrorData(_extends({}, errorData, {
          password: null,
          confirmPassword: null
        }));
      }
    }
  }, [formData.password, formData.confirmPassword]);
  return React__default.createElement(StyledWrapper, null, error && React__default.createElement(Message, {
    type: MessageType.Error,
    text: error,
    onClose: onErrorClose
  }), React__default.createElement("form", {
    onSubmit: onSubmit,
    name: "authorizer-reset-password-form"
  }, React__default.createElement("div", {
    className: styles['styled-form-group']
  }, React__default.createElement("label", {
    className: styles['form-input-label'],
    htmlFor: "authorizer-reset-password"
  }, React__default.createElement("span", null, "* "), "Password"), React__default.createElement("input", {
    name: "password",
    id: "authorizer-reset-password",
    className: styles['form-input-field'] + " " + (errorData.password ? styles['input-error-content'] : null),
    placeholder: "********",
    type: "password",
    value: formData.password || '',
    onChange: function onChange(e) {
      return onInputChange('password', e.target.value);
    }
  }), errorData.password && React__default.createElement("div", {
    className: styles['form-input-error']
  }, errorData.password)), React__default.createElement("div", {
    className: styles['styled-form-group']
  }, React__default.createElement("label", {
    className: styles['form-input-label'],
    htmlFor: "authorizer-reset-confirm-password"
  }, React__default.createElement("span", null, "* "), "Confirm Password"), React__default.createElement("input", {
    name: "confirmPassword",
    id: "authorizer-reset-confirm-password",
    className: styles['form-input-field'] + " " + (errorData.confirmPassword ? styles['input-error-content'] : null),
    placeholder: "********",
    type: "password",
    value: formData.confirmPassword || '',
    onChange: function onChange(e) {
      return onInputChange('confirmPassword', e.target.value);
    }
  }), errorData.confirmPassword && React__default.createElement("div", {
    className: styles['form-input-error']
  }, errorData.confirmPassword)), config.is_strong_password_enabled && React__default.createElement(React__default.Fragment, null, React__default.createElement(PasswordStrengthIndicator, {
    value: formData.password || '',
    setDisableButton: setDisableContinueButton
  }), React__default.createElement("br", null)), React__default.createElement(StyledButton, {
    type: "submit",
    disabled: loading || disableContinueButton || !!errorData.password || !!errorData.confirmPassword || !formData.password || !formData.confirmPassword,
    appearance: ButtonAppearance.Primary
  }, loading ? "Processing ..." : "Continue")));
};

var AuthorizerRoot = function AuthorizerRoot(_ref) {
  var _searchParams$get;
  var onLogin = _ref.onLogin,
    onSignup = _ref.onSignup,
    onMagicLinkLogin = _ref.onMagicLinkLogin,
    onForgotPassword = _ref.onForgotPassword,
    roles = _ref.roles;
  var _useState = React.useState(Views.Login),
    view = _useState[0],
    setView = _useState[1];
  var _useAuthorizer = useAuthorizer(),
    config = _useAuthorizer.config;
  var searchParams = new URLSearchParams(hasWindow() ? window.location.search : "");
  var state = searchParams.get('state') || createRandomString();
  var scope = searchParams.get('scope') ? (_searchParams$get = searchParams.get('scope')) == null ? void 0 : _searchParams$get.toString().split(' ') : ['openid', 'profile', 'email'];
  var urlProps = {
    state: state,
    scope: scope
  };
  var redirectURL = searchParams.get('redirect_uri') || searchParams.get('redirectURL');
  if (redirectURL) {
    urlProps.redirectURL = redirectURL;
  } else {
    urlProps.redirectURL = hasWindow() ? window.location.origin : redirectURL;
  }
  urlProps.redirect_uri = urlProps.redirectURL;
  return React__default.createElement(StyledWrapper, null, React__default.createElement(AuthorizerSocialLogin, {
    urlProps: urlProps,
    roles: roles
  }), view === Views.Login && config.is_basic_authentication_enabled && !config.is_magic_link_login_enabled && React__default.createElement(AuthorizerBasicAuthLogin, {
    setView: setView,
    onLogin: onLogin,
    urlProps: urlProps,
    roles: roles
  }), view === Views.Signup && config.is_basic_authentication_enabled && !config.is_magic_link_login_enabled && config.is_sign_up_enabled && React__default.createElement(AuthorizerSignup, {
    setView: setView,
    onSignup: onSignup,
    urlProps: urlProps,
    roles: roles
  }), view === Views.Login && config.is_magic_link_login_enabled && React__default.createElement(AuthorizerMagicLinkLogin, {
    onMagicLinkLogin: onMagicLinkLogin,
    urlProps: urlProps,
    roles: roles
  }), view === Views.ForgotPassword && React__default.createElement(AuthorizerForgotPassword, {
    setView: setView,
    onForgotPassword: onForgotPassword,
    urlProps: urlProps
  }));
};

exports.Authorizer = AuthorizerRoot;
exports.AuthorizerBasicAuthLogin = AuthorizerBasicAuthLogin;
exports.AuthorizerForgotPassword = AuthorizerForgotPassword;
exports.AuthorizerMagicLinkLogin = AuthorizerMagicLinkLogin;
exports.AuthorizerProvider = AuthorizerProvider;
exports.AuthorizerResetPassword = AuthorizerResetPassword;
exports.AuthorizerSignup = AuthorizerSignup;
exports.AuthorizerSocialLogin = AuthorizerSocialLogin;
exports.AuthorizerVerifyOtp = AuthorizerVerifyOtp;
exports.useAuthorizer = useAuthorizer;
//# sourceMappingURL=authorizer-svelte.cjs.development.js.map
